#!/usr/bin/perl -wT
#

#-----------------#
# Declare modules #
#-----------------#
use strict;                               # make me be good
use Fcntl qw(:DEFAULT :flock);            # file locking ability
use CGI::Carp qw(fatalsToBrowser);        # output error messages to the browser
use CGI;
delete @ENV{qw(IFS CDPATH ENV BASH_ENV)}; # Make %ENV safer
$ENV{PATH} = "";                          # unset so taint checking doesn't freak checklogin.pl
$| = 1;                                   # print output directly - do not buffer

#---------------------------------------------------------------#
# EXP Global Configuration                                      #
#---------------------------------------------------------------#
use vars qw( %config %param %user %lang_text %lang_err );

$config{version}           = "2002.06.09.1";
$config{databaseversion}   = "1.0";                  # exp supported database version
$config{md5_salt}          = "makes_the_input_to_md5_more_unique";
$config{error}             = "";                     # error messages will be stored here

( $config{systemroot}    ) = $ENV{SCRIPT_FILENAME} =~ /(.*)\/.*$/;           # Set these by hand if no Apache
( $config{serverroot}    ) = $ENV{SCRIPT_NAME} =~ /(.*)\/.*$/;
$config{serverroot}        = "http://$ENV{SERVER_NAME}$config{serverroot}";
$config{script}            = "http://$ENV{SERVER_NAME}$ENV{SCRIPT_NAME}";

$config{userdata}          = "userdata";             # where userdata is stored
$config{defaultlanguage}   = "en";                   # default language file
$config{langcharset}       = "iso-8859-1";           # default character set for language
$config{readdataformat}    = "xml";
$config{writedataformat}   = "xml";

#-------------------------------------------------#
# core program flow                               #
#-------------------------------------------------#
# The CGI::Simple stuff is commented out for now so it runs on most peoples system
#$CGI::Simple::POST_MAX = 3_145_728;                      # max upload via post default 3Mb
#$CGI::Simple::DISABLE_UPLOADS = 0;                       # enable uploads
#  $CGI::Simple::NPH = 1;                                # non-parsed headers
my $cgi = new CGI;                               # initialize the cgi object
#$cgi -> no_cache(1);                                     # browsers: do not cache pages
print $cgi->header();

%param = $cgi->Vars("|");                                # put the query string or post data into a hash


get_entry();

#-------------------------------------------------#
# end core program flow                           #
#-------------------------------------------------#

#-------------#
# subroutines #
#-------------#
sub dienice {
    my ($msg) = @_;
    print "<h1 class=\"warning\">Error</h1>\n";
    print "$msg\n<br><br>Last system error:<br>\n$!<br>\n$@<br>\n";
    writelog($msg);
    exit 0;
}

#------------------------------------------------------------#
# Database handling                                          #
#------------------------------------------------------------#
sub get_entry {
# ($userid, $dataset, $id_arrayref || match expression)
# Get all of the details of particular entries
    my $userid = "alex";
    my $dataset = "userconf.xml";
    my $file = "$config{systemroot}/$config{userdata}/$userid/$dataset";
    print "The file is: $file<br><br>";
    if ($config{readdataformat} eq "xml") {
 #      require XML::Parser::Lite; # dynamically load an available parser, or PurePerl if nothing else
 #       import XML::Parser::Lite;  # Bring modules features into current package


 #      my $parser = new XML::Parser::Lite;

 #       $parser->setHandlers( Init    => \&start_document,
 #                             Start   => \&start_element,
 #                             Char    => \&characters,
 #                             End     => \&end_element);

 #        $parser->parse("<check>Check</check>");

        require XML::SAX::ParserFactory; # dynamically load an available parser, or PurePerl if nothing else
        import XML::SAX::ParserFactory;  # Bring modules features into current package
        my $handler = EXPSAXHandler->new();
        my $parser = XML::SAX::ParserFactory->parser( Handler => $handler); 
        $parser->parse_uri($file);
 
        package EXPSAXHandler;

        sub new {
            my $type = shift;
            return bless {}, $type;
        }

        sub start_document {
            my ($self, $element) = @_;
            print "Starting document...<br>\n";
        }

        sub start_element {
            my ($self, $element) = @_;
            print "Starting element $element->{Name}<br>\n";
        }

        sub end_element {
            my ($self, $element) = @_;
            print "Ending element $element->{Name}<br>\n";
        }

        sub characters {
            my ($self, $characters->{Data}<br>) = @_;
            print "characters: $characters\n";
        }

       1;
    }
# Returns the entries as a hashref
}

sub add_entry {
# ($userid, $dataset, $hashreftodatabeingadded)
# Add an entry to the database. The hashref contains the structure of the data.
# So if the hashref looks like:
# 
# The resulting dataentry will look like:
#
# Returns 1 for success, 0 for failure
}

sub rem_entry {
# ($userid, $dataset, $id_arrayref)
# Removes entries from the database based on id numbers array

# Returns the number of entries deleted and sets error to any ids not deleted
}

sub mod_entry {
# ($userid, $dataset, $id, $hashref_of_fields_to_modify)
# Modifies an entry. Modifies the fields that match the key in the hashref
# with the value of that key.

# Returns 1 for success, 0 for failure
}

sub search_entries {
# ($userid, $dataset, $search_string)
# Searches for a particular string in a dataset group of entries

# Returns an arrayref of entries that match 
}

sub write_database {
    #
}

#-----------------#
# MD5 ROUTINES    #
#-----------------#
sub md5_hex {
	# Modified by Alex Teslik <alex@acatysmoof.com> from Christian Lackas'
	# <delta@lackas.net> MD5.pm at www.cpan.org:
	# $Id: MD5.pm,v 1.16 2000/09/19 22:19:31 lackas Exp $
	# Copyright 2000 Christian Lackas, Imperia Software Solutions
	# Copyright 1998-1999 Gisle Aas.
	# Copyright 1995-1996 Neil Winton.
	# Copyright 1991-1992 RSA Data Security, Inc.
	# derived from the RSA Data Security, Inc. MD5 Message-Digest Algorithm.

	require integer;
	gen_code();

	# I-Vektor
	sub A() { 0x67_45_23_01 }
	sub B() { 0xef_cd_ab_89 }
	sub C() { 0x98_ba_dc_fe }
	sub D() { 0x10_32_54_76 }

	# for internal use
	sub MAX() { 0xFFFFFFFF }

	# pad a message to a multiple of 64
	sub padding($) {
	    my $l = length (my $msg = shift() . chr(128));
	    $msg .= "\0" x (($l%64<=56?56:120)-$l%64);
	    $l = ($l-1)*8;
	    $msg .= pack 'VV', $l & MAX , ($l >> 16 >> 16);
	}

	sub rotate_left($$) {
		($_[0] << $_[1]) | (( $_[0] >> (32 - $_[1])  )  & ((1 << $_[1]) - 1));
	}

	sub gen_code {
	  # Discard upper 32 bits on 64 bit archs.
	  my $MSK = ((1 << 16) << 16) ? ' & ' . MAX : '';
	  my %f = (
		FF => "X0=rotate_left((X3^(X1&(X2^X3)))+X0+X4+X6$MSK,X5)+X1$MSK;",
		GG => "X0=rotate_left((X2^(X3&(X1^X2)))+X0+X4+X6$MSK,X5)+X1$MSK;",
		HH => "X0=rotate_left((X1^X2^X3)+X0+X4+X6$MSK,X5)+X1$MSK;",
		II => "X0=rotate_left((X2^(X1|(~X3)))+X0+X4+X6$MSK,X5)+X1$MSK;",
	  );

	  my %s = (  # shift lengths
		S11 => 7, S12 => 12, S13 => 17, S14 => 22, S21 => 5, S22 => 9, S23 => 14,
		S24 => 20, S31 => 4, S32 => 11, S33 => 16, S34 => 23, S41 => 6, S42 => 10,
		S43 => 15, S44 => 21
	  );

	  my $insert = "";

	  my %data = (
		a01	=> 'FF,$a,$b,$c,$d,$_[4],7,0xd76aa478,/* 1 */',
		a02	=> 'FF,$d,$a,$b,$c,$_[5],12,0xe8c7b756,/* 2 */',
		a03	=> 'FF,$c,$d,$a,$b,$_[6],17,0x242070db,/* 3 */',
		a04	=> 'FF,$b,$c,$d,$a,$_[7],22,0xc1bdceee,/* 4 */',
		a05	=> 'FF,$a,$b,$c,$d,$_[8],7,0xf57c0faf,/* 5 */',
		a06	=> 'FF,$d,$a,$b,$c,$_[9],12,0x4787c62a,/* 6 */',
		a07	=> 'FF,$c,$d,$a,$b,$_[10],17,0xa8304613,/* 7 */',
		a08	=> 'FF,$b,$c,$d,$a,$_[11],22,0xfd469501,/* 8 */',
		a09	=> 'FF,$a,$b,$c,$d,$_[12],7,0x698098d8,/* 9 */',
		a10	=> 'FF,$d,$a,$b,$c,$_[13],12,0x8b44f7af,/* 10 */',
		a11	=> 'FF,$c,$d,$a,$b,$_[14],17,0xffff5bb1,/* 11 */',
		a12	=> 'FF,$b,$c,$d,$a,$_[15],22,0x895cd7be,/* 12 */',
		a13	=> 'FF,$a,$b,$c,$d,$_[16],7,0x6b901122,/* 13 */',
		a14	=> 'FF,$d,$a,$b,$c,$_[17],12,0xfd987193,/* 14 */',
		a15	=> 'FF,$c,$d,$a,$b,$_[18],17,0xa679438e,/* 15 */',
		a16	=> 'FF,$b,$c,$d,$a,$_[19],22,0x49b40821,/* 16 */',
		a17	=> 'GG,$a,$b,$c,$d,$_[5],5,0xf61e2562,/* 17 */',
		a18	=> 'GG,$d,$a,$b,$c,$_[10],9,0xc040b340,/* 18 */',
		a19	=> 'GG,$c,$d,$a,$b,$_[15],14,0x265e5a51,/* 19 */',
		a20	=> 'GG,$b,$c,$d,$a,$_[4],20,0xe9b6c7aa,/* 20 */',
		a21	=> 'GG,$a,$b,$c,$d,$_[9],5,0xd62f105d,/* 21 */',
		a22	=> 'GG,$d,$a,$b,$c,$_[14],9,0x2441453,/* 22 */',
		a23	=> 'GG,$c,$d,$a,$b,$_[19],14,0xd8a1e681,/* 23 */',
		a24	=> 'GG,$b,$c,$d,$a,$_[8],20,0xe7d3fbc8,/* 24 */',
		a25	=> 'GG,$a,$b,$c,$d,$_[13],5,0x21e1cde6,/* 25 */',
		a26	=> 'GG,$d,$a,$b,$c,$_[18],9,0xc33707d6,/* 26 */',
		a27	=> 'GG,$c,$d,$a,$b,$_[7],14,0xf4d50d87,/* 27 */',
		a28	=> 'GG,$b,$c,$d,$a,$_[12],20,0x455a14ed,/* 28 */',
		a29	=> 'GG,$a,$b,$c,$d,$_[17],5,0xa9e3e905,/* 29 */',
		a30	=> 'GG,$d,$a,$b,$c,$_[6],9,0xfcefa3f8,/* 30 */',
		a31	=> 'GG,$c,$d,$a,$b,$_[11],14,0x676f02d9,/* 31 */',
		a32	=> 'GG,$b,$c,$d,$a,$_[16],20,0x8d2a4c8a,/* 32 */',
		a33	=> 'HH,$a,$b,$c,$d,$_[9],4,0xfffa3942,/* 33 */',
		a34	=> 'HH,$d,$a,$b,$c,$_[12],11,0x8771f681,/* 34 */',
		a35	=> 'HH,$c,$d,$a,$b,$_[15],16,0x6d9d6122,/* 35 */',
		a36	=> 'HH,$b,$c,$d,$a,$_[18],23,0xfde5380c,/* 36 */',
		a37	=> 'HH,$a,$b,$c,$d,$_[5],4,0xa4beea44,/* 37 */',
		a38	=> 'HH,$d,$a,$b,$c,$_[8],11,0x4bdecfa9,/* 38 */',
		a39	=> 'HH,$c,$d,$a,$b,$_[11],16,0xf6bb4b60,/* 39 */',
		a40	=> 'HH,$b,$c,$d,$a,$_[14],23,0xbebfbc70,/* 40 */',
		a41	=> 'HH,$a,$b,$c,$d,$_[17],4,0x289b7ec6,/* 41 */',
		a42	=> 'HH,$d,$a,$b,$c,$_[4],11,0xeaa127fa,/* 42 */',
		a43	=> 'HH,$c,$d,$a,$b,$_[7],16,0xd4ef3085,/* 43 */',
		a44	=> 'HH,$b,$c,$d,$a,$_[10],23,0x4881d05,/* 44 */',
		a45	=> 'HH,$a,$b,$c,$d,$_[13],4,0xd9d4d039,/* 45 */',
		a46	=> 'HH,$d,$a,$b,$c,$_[16],11,0xe6db99e5,/* 46 */',
		a47	=> 'HH,$c,$d,$a,$b,$_[19],16,0x1fa27cf8,/* 47 */',
		a48	=> 'HH,$b,$c,$d,$a,$_[6],23,0xc4ac5665,/* 48 */',
		a49	=> 'II,$a,$b,$c,$d,$_[4],6,0xf4292244,/* 49 */',
		a50	=> 'II,$d,$a,$b,$c,$_[11],10,0x432aff97,/* 50 */',
		a51	=> 'II,$c,$d,$a,$b,$_[18],15,0xab9423a7,/* 51 */',
		a52	=> 'II,$b,$c,$d,$a,$_[9],21,0xfc93a039,/* 52 */',
		a53	=> 'II,$a,$b,$c,$d,$_[16],6,0x655b59c3,/* 53 */',
		a54	=> 'II,$d,$a,$b,$c,$_[7],10,0x8f0ccc92,/* 54 */',
		a55	=> 'II,$c,$d,$a,$b,$_[14],15,0xffeff47d,/* 55 */',
		a56	=> 'II,$b,$c,$d,$a,$_[5],21,0x85845dd1,/* 56 */',
		a57	=> 'II,$a,$b,$c,$d,$_[12],6,0x6fa87e4f,/* 57 */',
		a58	=> 'II,$d,$a,$b,$c,$_[19],10,0xfe2ce6e0,/* 58 */',
		a59	=> 'II,$c,$d,$a,$b,$_[10],15,0xa3014314,/* 59 */',
		a60	=> 'II,$b,$c,$d,$a,$_[17],21,0x4e0811a1,/* 60 */',
		a61	=> 'II,$a,$b,$c,$d,$_[8],6,0xf7537e82,/* 61 */',
		a62	=> 'II,$d,$a,$b,$c,$_[15],10,0xbd3af235,/* 62 */',
		a63	=> 'II,$c,$d,$a,$b,$_[6],15,0x2ad7d2bb,/* 63 */',
		a64	=> 'II,$b,$c,$d,$a,$_[13],21,0xeb86d391,/* 64 */'
	  );

	  for (sort(keys %data)) {
		$_ = $data{$_};
		chomp;
		next unless /^[FGHI]/;
		my ($func,@x) = split /,/;
		my $c = $f{$func};
		$c =~ s/X(\d)/$x[$1]/g;
		$c =~ s/(S\d{2})/$s{$1}/;
	        $c =~ s/^(.*)=rotate_left\((.*),(.*)\)\+(.*)$//;
		$c = "\$r = $2;
	        $1 = ((\$r << $3) | ((\$r >> (32 - $3))  & ((1 << $3) - 1))) + $4";
		$insert .= "\t$c\n";
	  }

	  my $dump = '
	  sub round {
		my ($a,$b,$c,$d) = @_[0 .. 3];
		my $r;
		' . $insert . '
		$_[0]+$a' . $MSK . ', $_[1]+$b ' . $MSK .
	        ', $_[2]+$c' . $MSK . ', $_[3]+$d' . $MSK . ';
	  }';
	  eval $dump;
	}

	sub md5(@){
		my $message = padding(join'',@_);
		my ($a,$b,$c,$d) = (A,B,C,D);
		my $i;
		for $i (0 .. (length $message)/64-1) {
			my @X = unpack 'V16', substr $message,$i*64,64;
			($a,$b,$c,$d) = round($a,$b,$c,$d,@X);
		}
		pack 'V4',$a,$b,$c,$d;
	}

	return (unpack 'H*', &md5); # return md5 output in printable hex format
}
